unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    xedit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    goBtn: TBitBtn;
    msglabel: TStaticText;
    resetBTn: TBitBtn;
    Yedit: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure goBtnClick(Sender: TObject);
    procedure resetBTnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const vpts : array[1..7] of word = (0,70,140,260,380,500,139);
      msg1 = 'press GO...to start';
      msg2 = 'upper limit reached';
      msg3 = 'pause....';
      msg4 = 'X,Y modified.....press GO';

var x,y  : dword;
    a,b,c : dword;
    h : dword;
    lineNr : byte;

procedure setXY(xx,yy : word);
begin
 x := xx;
 y := yy;
 form1.xedit.Text := inttostr(x);
 form1.Yedit.Text := inttostr(y);
end;

function GetTextRect(line,field : byte) : Trect;
begin
 with result do
  begin
   left := vpts[field]+1;
   right := vpts[field+1]-2;
   top := (line-1)*20+1;
   bottom := top + 19;
  end;
end;

procedure clearLine(nr : byte);
var i : byte;
    r : Trect;
begin
 with form1.PaintBox1.Canvas do
  for i := 1 to 5 do
   begin
    r := GetTextRect(nr,i);
    brush.Style := bsSolid;
    fillrect(r);
   end;
end;

procedure writeline;
//use lineNr,x,y,a,b,c
var i : byte;
    s : string;
    r : Trect;
begin
 clearline(lineNr);
 with form1.paintbox1.canvas do
  for i := 1 to 5 do
   begin
    r := GetTextRect(lineNr,i);
    case i of
     1 : s := inttostr(x);
     2 : s := inttostr(y);
     3 : s := inttostr(a);
     4 : s := inttostr(b);
     5 : s := inttostr(c);
    end;
    brush.style := bsClear;
    textout(r.left+3,r.Top+1,s);
   end;//for
end;

function GCD(p,q : dword) : dword;
//return Greatest Common Divisor of p,q
begin
 repeat
  if p < q then begin
                 h := p;
                 p := q;
                 q := h;
                end;
  p := p mod q;
 until p = 0;
 result := q;
end;

procedure GOP3;
//generate triples list
var pstat : byte;    //0:GO  1:upper X 2:lower X 3.list full
begin
 form1.msglabel.Caption := 'busy...';
 application.ProcessMessages;
 pstat := 0;
 while pstat = 0 do
  begin
   a := sqr(x) - sqr(y);
   b := 2*x*y;
   if GCD(a,b) = 1 then
    begin
     c := sqr(x) + sqr(y);
     writeline;
     inc(lineNr);
     if lineNr = 35 then pstat := 2;
    end;
   inc(y);
   if y = x then begin
                  inc(x);
                  y := 1;
                  if (x > 9999) then pstat := 1;
                 end;
  end;//while
 case pstat of
  1 : begin
        form1.msglabel.Caption := msg2;
        x := 9999; y := 9998;
      end;
  2 : form1.msglabel.Caption := msg3;
 end;
 setxy(x,y);
end;

procedure TForm1.goBtnClick(Sender: TObject);
var eflag : boolean;
begin
 eflag := false;
 if (length(xedit.Text) = 0) or (length(yedit.Text) = 0) then
  begin
   setXY(2,1);
   eflag := true;
  end;
 x := strtoint(Xedit.Text);
 y := strtoint(Yedit.text);
 if (x < 2) then
  begin
   x := 2;
   eflag := true;
  end;
 if (y = 0) then
  begin
   y := 1;
   eflag := true;
  end;
 if (x <= y) then
  begin
   y := x - 1;
   eflag := true;
  end;
 setXY(x,y);
 lineNr := 1;
 if eflag then msglabel.Caption := msg4 else GOP3;
end;

procedure TForm1.resetBTnClick(Sender: TObject);
var line : byte;
begin
 setXY(2,1);
 for line := 1 to 34 do clearline(line);
 msglabel.Caption := msg1;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 setXY(2,1);
 msglabel.Caption := msg1;
 label8.Caption := 'a'+#178+' + b'+#178+' = c'+#178;
 label9.Caption := 'a = '+'x'+#178+' - y'+#178;
 label10.Caption := 'b = 2xy';
 label11.Caption := 'c = '+'x'+#178+' + y'+#178;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
//triples list background
var i : word;
begin
 with paintbox1 do with canvas do
  begin
   pen.Width := 1;
   pen.color := $000000;
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   i := 0;
   while i < height do
    begin
     moveto(0,i);
     lineto(width,i);
     inc(i,20);
    end;
  for i := 1 to 7 do
   begin
    moveto(vpts[i],0);
    lineto(vpts[i],height);
  end;
 end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if not (key in ['0'..'9',#08]) then key := #0;
end;

end.
